# audio_hack.py
# $Rev$
# Copyright (c) 2015 Able Systems Limited. All rights reserved.
'''This simple code example is provided as-is, and is for demonstration
purposes only. Able Systems takes no responsibility for any system
implementations based on this code.

This script reads-in a file specified on the command line and 
uses wiringpi's tone generation functions to play the notes therein.

This is a very primitive script with PLENTY of opportunity for
improvement!

Copyright (c) 2015, Able Systems Ltd. All rights reserved.
'''
import argparse
import logging
import platform
import struct
import os
import sys
import time
import wiringpi2

OUTPUT = 1
GPIO2 = 2

OFF = 0

FREQ_CL = 262
FREQ_D  = 294
FREQ_E  = 330
FREQ_F  = 349
FREQ_G  = 392
FREQ_A  = 440
FREQ_B  = 494
FREQ_CH = 523

DELAY = 0.1

def parse_arguments():
    '''Parse the filename argument passed to the script. If no
    argument is supplied, a default filename is provided.
    '''
    default_file = "song1.txt"
    parser = argparse.ArgumentParser()
    parser.add_argument('filename', help='the image file to print',
                        nargs='?', default=default_file)
    return parser.parse_args()


def main():        


    # This script is written using the PIL which requires Python 2
    if sys.version_info[0] != 2:
        sys.exit('This application requires python 2.')

    if platform.system() != 'Linux':
        sys.exit('This script has only been written for Linux')
    
    args = parse_arguments()

    wiringpi2.wiringPiSetupGpio()

    wiringpi2.pinMode(GPIO2,OUTPUT)
    wiringpi2.softToneCreate(GPIO2) # Configure audio output

    xmas_tune = open(args.filename, 'r')
    for line in xmas_tune: 
        time.sleep(DELAY)
        wiringpi2.softToneWrite(GPIO2, OFF)
        time.sleep(DELAY)
        line = line[0]
        print("Playing: {}".format(line))
        if line == 'c':
            wiringpi2.softToneWrite(GPIO2, FREQ_CL)
        elif line == 'D':
            wiringpi2.softToneWrite(GPIO2, FREQ_D)
        elif line == 'E':
            wiringpi2.softToneWrite(GPIO2, FREQ_E)
        elif line == 'F':
            wiringpi2.softToneWrite(GPIO2, FREQ_F)
        elif line == 'G':
            wiringpi2.softToneWrite(GPIO2, FREQ_G)
        elif line == 'A':
            wiringpi2.softToneWrite(GPIO2, FREQ_A)
        elif line == 'B':
            wiringpi2.softToneWrite(GPIO2, FREQ_B)
        elif line == 'C':
            wiringpi2.softToneWrite(GPIO2, FREQ_CH)
        else:
            wiringpi2.softToneWrite(GPIO2, OFF)


    time.sleep(DELAY)
    xmas_tune.close()

if __name__ == '__main__':
    main()
